﻿package meyermike.minild10
{
    /**
     * ...
     * @author Mike Meyer
     */
    public class Family extends MiniLD10Character
    {
        public override function Init():void
        {
            super.Init();

            CreateGraphics(GetColor());
            Restart();
        }

        private var mDirection:Number = 1;

        protected function GetColor():Number { return Constants.PLAYER_COLOR; }

        public override function Beat(beat:Number):void
        {
            if (Math.random() < Constants.CHANCE_FOR_TURN_ON_BEAT)
            {
                mDirection *= -1;
            }
        }

        protected override function Walk(elapsedTime:Number):void
        {
            super.Walk(elapsedTime);

            if (!IsDying())
            {
                var currentDirection:Number = 0;
                if (this.dx > 0)
                    currentDirection = 1;
                else if (this.dx < 0)
                    currentDirection = -1;

                // controls a bit differently on the ground
                if (IsOnGround)
                {
                    // changing direction or stopping
                    if ( (currentDirection != 0) && (mDirection != currentDirection) )
                    {
                        var ddx:Number = Constants.PLAYER_STOP_ACCEL * elapsedTime;

                        if ( ddx > Math.abs(this.dx) )
                        {
                            this.dx = 0;
                        }
                        else
                        {
                            if (this.dx > 0 )
                                this.dx -= ddx;
                            else
                                this.dx += ddx;
                        }
                    }
                    else // accelerating
                    {
                        this.dx += mDirection * Constants.PLAYER_WALK_ACCEL * elapsedTime;
                    }
                }
                else
                {
                    this.dx += mDirection * Constants.NPC_AIR_ACCEL * elapsedTime;
                }

                // max speed
                if (this.dx > Constants.NPC_WALK_MAX_SPEED)
                {
                    this.dx = Constants.NPC_WALK_MAX_SPEED;
                }
                if (this.dx < -Constants.NPC_WALK_MAX_SPEED)
                {
                    this.dx = -Constants.NPC_WALK_MAX_SPEED;
                }

                // flip graphics
                if (mDirection > 0)
                    this.scaleX = 1.0;
                if (mDirection < 0)
                    this.scaleX = -1.0;
            }
        }
    }
}
