﻿package meyermike.minild9
{
    import flash.display.Bitmap;
    import flash.geom.Rectangle;
    import meyermike.GameObject;
    import meyermike.Util;
    /**
     * ...
     * @author Mike Meyer
     */
    public class Blood extends GameObject
    {
        [Embed(source='../../../assets/Blood.png')]
        private static var GraphicClass:Class;

        private var mGraphic:Bitmap;

        /**
         * initial setup and re-init when reusing
         */
        public override function Init():void
        {
            super.Init();

            CreateGraphics();
            Restart();
        }

        /**
         *
         */
        private function CreateGraphics():void
        {
            if (null == mGraphic)
            {
                mGraphic = new GraphicClass();
                mGraphic.x = -0.5 * mGraphic.width;
                mGraphic.y = -0.5 * mGraphic.height;
                this.addChild(mGraphic);
            }
        }

        /**
         * set initial values after spawning
         */
        private function Restart():void
        {
            this.dx = Util.Lerp(-100, 100, Math.random());
            this.dy = Util.Lerp(0, -300, Math.random());
        }
        /**
         * get rid of these when they fall down too far
         */
        public override function IsAlive():Boolean
        {
            return (this.getBounds(stage).top < stage.stageHeight);
        }
    }

}
