﻿package meyermike.minild9 
{
    import flash.display.Bitmap;
    import flash.display.Sprite;
    
    /**
     * ...
     * @author Mike Meyer
     */
    public class Cape extends Sprite
    {
        [Embed(source='../../../assets/cape1.png')]
        private static var Frame1GraphicClass:Class;
        [Embed(source='../../../assets/cape2.png')]
        private static var Frame2GraphicClass:Class;
        [Embed(source='../../../assets/cape3.png')]
        private static var Frame3GraphicClass:Class;
        [Embed(source='../../../assets/cape4.png')]
        private static var Frame4GraphicClass:Class;
        
        private static const FRAME_LENGTH:Number = 0.1;
        private static const NUM_FRAMES:uint = 4;
        private var mAnimTimer:Number;
        
        private var mCapeFrame1:Bitmap;
        private var mCapeFrame2:Bitmap;
        private var mCapeFrame3:Bitmap;
        private var mCapeFrame4:Bitmap;
        
        private var mCurCapeFrame:uint;
        
        public function Cape()
        {
            mCurCapeFrame = 0;
            mAnimTimer = 0;
            CreateGraphics();
        }
        
        /**
         * create the bitmaps
         */
        public function CreateGraphics():void
        {
            mCapeFrame1 = new Frame1GraphicClass();
            mCapeFrame2 = new Frame2GraphicClass();
            mCapeFrame3 = new Frame3GraphicClass();
            mCapeFrame4 = new Frame4GraphicClass();
            
            var frames:Array = [mCapeFrame1, mCapeFrame2, mCapeFrame3, mCapeFrame4];
            for each (var frameGraphic:Bitmap in frames)
            {
                frameGraphic.x = -0.5 * frameGraphic.width;
                frameGraphic.y = -0.5 * frameGraphic.height;
                this.addChild(frameGraphic);
            }
        }
        
        /**
         * per-frame update
         * @param	elapsedTime - time since the last frame
         */
        public function Update(elapsedTime:Number):void
        {
            mAnimTimer -= elapsedTime;
            
            if (mAnimTimer <= 0.0)
            {
                mAnimTimer = FRAME_LENGTH;
                mCurCapeFrame = (mCurCapeFrame + 1) % NUM_FRAMES;
                SwitchFrame(mCurCapeFrame);
            }
        }
        
        /**
         * make the right anim frame graphic visible
         */
        private function SwitchFrame(frame:uint):void
        {
            mCapeFrame1.visible = false;
            mCapeFrame2.visible = false;
            mCapeFrame3.visible = false;
            mCapeFrame4.visible = false;
            
            switch(frame)
            {
                case 0:
                    mCapeFrame1.visible = true;
                    break;
                case 1:
                    mCapeFrame2.visible = true;
                    break;
                case 2:
                    mCapeFrame3.visible = true;
                    break;
                case 3:
                    mCapeFrame4.visible = true;
                    break;
            }
        }
    }
    
}