﻿package meyermike.minild9 
{
    import flash.events.Event;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import flash.media.SoundLoaderContext;
    import flash.media.SoundTransform;
    import flash.net.URLRequest;
    import flash.utils.Timer;
    import meyermike.Util;
    
    /**
     * ...
     * @author Mike Meyer
     */
    public class Music 
    {
        private static const sSongUrlPrefix:String = "http://www.meyermike.com/games/minild9/";
        private static const sSongList:Array = [
            "angrybass.mp3",
            "annoyed303synth.mp3",
            "darkthingscrawlupinyourskullsynth.mp3",
            "determined303synth.mp3",
            "drumloop1.mp3",
            "drumloop2.mp3",
            "drumloop3.mp3",
            "drumloop4.mp3",
            "drumloop5.mp3",
            "drumloop6.mp3",
            "drumloop7.mp3",
            "drumloop8.mp3",
            "drumloop9.mp3",
            "drumloop10.mp3",
            "grungybass.mp3",
            "lofimelody.mp3",
            "lofipad.mp3",
            "ogglysynth.mp3",
            "synthguitar.mp3",
            "tonalbass.mp3",
            "trancechordsynth.mp3",
            "twinklysynth.mp3" ];
        
        private static var sMusic:Sound;
        private static var sMusicChannel:SoundChannel;
        
        public static function StartNewMusic():void
        {
            if (null != Music.sMusicChannel)
            {
                Music.sMusicChannel.stop();
            }
            
            Music.sMusic = new Sound();
            var file:String = Util.RandomOneOf(Music.sSongList);
            var request:URLRequest = new URLRequest(Music.sSongUrlPrefix + file);
            var context:SoundLoaderContext = new SoundLoaderContext(8000, true);
            Music.sMusic.load(request, context);
            LoopMusic();
            
            trace("playing", Music.sSongUrlPrefix + file);
        }
        
        private static function LoopMusic(e:Event = null):void
        {
            if (null != Music.sMusicChannel)
            {
                Music.sMusicChannel.removeEventListener(Event.SOUND_COMPLETE, LoopMusic);
            }
            
            Music.sMusicChannel = Music.sMusic.play(0, 1, new SoundTransform(0.5) );
            Music.sMusicChannel.addEventListener(Event.SOUND_COMPLETE, LoopMusic);
        }
        
        
        public static function StopMusic():void
        {
            if (null != Music.sMusicChannel)
            {
                Music.sMusicChannel.stop();
            }
        }
    }
    
}