﻿package meyermike.widget
{
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import meyermike.squareversus.Constants;
    import meyermike.squareversus.Sounds;
    
    /**
     * ...
     * @author Mike Meyer
     */
    public class PulsingTextButton extends PulsingText
    {
        import flash.media.Sound;
        import flash.media.SoundChannel;
    
        [Embed(source='../../../../assets/syntchbass.mp3')]
        private static var HoverSoundClass:Class;
        private static var HoverSound:Sound;
        
        [Embed(source='../../../../assets/squaretone.mp3')]
        private static var ClickSoundClass:Class;
        private static var ClickSound:Sound;
        
        private static var SoundCh:SoundChannel;

        private var mHoverColor:Number = Constants.YELLOW;

        public function PulsingTextButton(config:Object = null)
        {
            super(config);
        }

        public override function Init(config:Object = null):void
        {
            super.Init(config);

            if (null != config)
            {
                if (null != config.hoverTextColor)
                {
                    mHoverColor = config.hoverTextColor;
                }
            }
            
            CreateSounds();

            AddMouseEventListeners();
        }

        private function CreateSounds():void
        {
            if (null == HoverSound)
            {
                HoverSound = new HoverSoundClass();
                ClickSound = new ClickSoundClass();
            }
        }
        
        public override function Shutdown():void
        {
            RemoveMouseEventListeners();
            super.Shutdown();
        }

        private function AddMouseEventListeners():void
        {
            mTextField.addEventListener(MouseEvent.ROLL_OVER, HandleRollOver);
            mTextField.addEventListener(MouseEvent.ROLL_OUT, HandleRollOut);
            mTextField.addEventListener(MouseEvent.MOUSE_UP, HandleMouseUp);
        }

        private function RemoveMouseEventListeners():void
        {
            mTextField.removeEventListener(MouseEvent.ROLL_OVER, HandleRollOver);
            mTextField.removeEventListener(MouseEvent.ROLL_OUT, HandleRollOut);
            mTextField.removeEventListener(MouseEvent.MOUSE_UP, HandleMouseUp);
        }

        private function HandleRollOver(evt:MouseEvent = null):void
        {
            mTextField.SetFontColor(mHoverColor);
            SoundCh = Sounds.PlaySound(HoverSound, SoundCh);
        }

        private function HandleRollOut(evt:MouseEvent = null):void
        {
            mTextField.SetFontColor(mColor);
        }
        
        private function HandleMouseUp(evt:MouseEvent = null):void
        {
            SoundCh = Sounds.PlaySound(ClickSound, SoundCh);
        }
    }

}